<?php

namespace NoccyLabs\InteractiveShell\Command\Commands;

use NoccyLabs\InteractiveShell\Command\ShellCommand;
use NoccyLabs\InteractiveShell\Context\ShellContext;

class Command extends ShellCommand
{
    private $callable;

    public function __construct(string $name, string $description, callable $callable)
    {
        parent::__construct();

        $this->callable = $callable;

        $this->setCommandName($name);
        $this->setDescription($description);
    }


    public function invoke(array $args, ShellContext $context)
    {
        call_user_func($this->callable, $args, $context);
    }
}