<?php

namespace NoccyLabs\InteractiveShell\Option;
use NoccyLabs\InteractiveShell\Option\Attribute\AsOption;
use ReflectionClass;

class ReflectedOptionSet extends AbstractOptionSet
{
    private object $class;

    public function __construct(object $class)
    {
        $reflectionClass = new ReflectionClass($class);
        
        foreach ($reflectionClass->getProperties() as $property) {

            $attributes = $property->getAttributes(AsOption::class);
            if (count($attributes) == 0) continue;

            $attribute = (array_shift($attributes))->newInstance();
            $this->bindOption(new ReflectedOption($class, $property, $attribute));
            
        }
    }

}